unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    ComboBox1: TComboBox;
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure FindFiles(FilesList: TStringList; StartDir, FileMask: string);
var
  SR: TSearchRec;
  DirList: TStringList;
  IsFound: Boolean;
  i: integer;
begin
  if StartDir[length(StartDir)] <> '\' then
    StartDir := StartDir + '\';

  { Build a list of the files in directory StartDir
     (not the directories!)                         }

  IsFound :=FindFirst(StartDir+FileMask, faAnyFile-faDirectory, SR) = 0;
  while IsFound do begin
    FilesList.Add(StartDir + SR.Name);
    IsFound := FindNext(SR) = 0;
  end;
  FindClose(SR);

  // Build a list of subdirectories
  DirList := TStringList.Create;
  IsFound := FindFirst(StartDir+'*.*', faAnyFile, SR) = 0;
  while IsFound do begin
    if ((SR.Attr and faDirectory) <> 0) and
         (SR.Name[1] <> '.') then
      DirList.Add(StartDir + SR.Name);
    IsFound := FindNext(SR) = 0;
  end;
  FindClose(SR);

  // Scan the list of subdirectories
  for i := 0 to DirList.Count - 1 do
    FindFiles(FilesList, DirList[i], FileMask);

  DirList.Free;
end;


procedure TForm1.FormCreate(Sender: TObject);
var
  a: Char;
begin
    ComboBox1.Clear;
    //P_CD-ROM
    For a := 'A' to 'Z' Do
     if GetDriveType(pChar(a + ':\')) = DRIVE_CDROM Then
        ComboBox1.Items.Add(a + ':\');
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var
  FilesList: TStringList;
begin
  FilesList := TStringList.Create;
  ListBox1.Clear;
  try
    if  ComboBox1.Text <> '' then
    FindFiles(FilesList, ComboBox1.Text,'*.MP3');
    ListBox1.Items.Assign(FilesList);
    ListBox1.Sorted:=true;   
  finally 
    FilesList.Free;
  end;
end;

end.
